#library "RANDMUS"
#include "zcommon.acs"

//#include "commonFuncs.h" // Even in making a silly music randomizer mod, I require ijon's funcs.

#define RANDOMMUS 461

int MusicRandomizerOn;
int MusicInfo;

int RandMusList[RANDOMMUS] = 
{
	"D_D1_11", // The Ultimate Doom
	"D_D1_12",
	"D_D1_13",
	"D_D1_14",
	"D_D1_15",
	"D_D1_16",
	"D_D1_17",
	"D_D1_18",
	"D_D1_19",
	"D_D1_21",
	"D_D1_22",
	"D_D1_23",
	"D_D1_24",
	"D_D1_26",
	"D_D1_27",
	"D_D1_28",
	"D_D1_31",
	"D_D1_32",
	"D_D1_33",
	"D_D1_38",
	"D_VICTOR",
	"D_D2_01", 	// Doom 2
	"D_D2_02",
	"D_D2_03",
	"D_D2_04",
	"D_D2_05",
	"D_D2_06",
	"D_D2_07",
	"D_D2_08",
	"D_D2_09",
	"D_D2_10",
	"D_D2_18",
	"D_D2_20",
	"D_D2_23",
	"D_D2_25",
	"D_D2_28",
	"D_D2_30",
	"D_D2_31",
	"D_D2_32",
	"D_D2_VIC",
	"STALKER", // Duke Nukem 3D
	"DETHTOLL",
	"STREETS",
	"WATRWLD1",
	"SNAKE1",
	"THECALL",
	"AHGEEZ",
	"FUTURMIL",
	"STORM",
	"GUTWRNCH",
	"ROBOCREP",
	"STALAG",
	"PIZZED",
	"ALIENZ",
	"XPLASMA",
	"ALFREDH",
	"GLOOMY",
	"INTENTS",
	"INHIDING",
	"FATCMDR",
	"NAMES",
	"SUBWAY",
	"INVADER",
	"GOTHAM",
	"233C",
	"LORDOFLA",
	"URBAN",
	"SPOOK",
	"WHOMP",
	"MISSIMP",
	"PREPD",
	"BAKEDGDS",
	"CF",
	"LEMCHILL",
	"POB",
	"WAREHAUS",
	"LAYERS",
	"FLOGHORN",
	"DEPART",
	"RESTRICT",
	"ITSGREEN",
	"CORNER", // Wolfenstein 3D
	"DUNGEON",
	"FUNKYOU",
	"GETTHEM",
	"GOINGAFT",
	"HEADACHE",
	"HITLWITZ",
	"NAZIRAP",
	"POW",
	"PREGNANT",
	"SEARCHIN",
	"SUSPENSE",
	"TWELFTH",
	"WARMARCH",
	"ZEROHOUR",
	"XDEATH", // Spear of Destiny
	"XFUNKIE",
	"XGETYOU",
	"XJAZNAZI",
	"XPUTIT",
	"XTIPTOE",
	"XTOWER2",
	"D_TNT_01", // TNT Evilution
	"D_TNT_02",
	"D_TNT_04",
	"D_TNT_05",
	"D_TNT_06",
	"D_TNT_07",
	"D_TNT_08",
	"D_TNT_10",
	"D_TNT_11",
	"D_TNT_14",
	"D_TNT_16",
	"D_TNT_20",
	"D_TNT_22",
	"D_TNT_31",
	"F_BUNNY", // Freedoom
	"F_C1M1",
	"F_C1M2",
	"F_C1M3",
	"F_C1M4",
	"F_C1M5",
	"F_C1M6",
	"F_C1M7",
	"F_C1M8",
	"F_C1M9",
	"F_C2M1",
	"F_C2M2",
	"F_C2M3",
	"F_C2M4",
	"F_C2M5",
	"F_C2M7",
	"F_C2M8",
	"F_C2M9",
	"F_C3M1",
	"F_C3M2",
	"F_C3M3",
	"F_C3M4",
	"F_C3M5",
	"F_C3M6",
	"F_C3M7",
	"F_C3M8",
	"F_C3M9",
	"F_DM01",
	"F_DM02",
	"F_DM03",
	"F_DM04",
	"F_DM05",
	"F_DM06",
	"F_DM07",
	"F_DM08",
	"F_DM09",
	"F_DM10",
	"F_DM11",
	"F_DM12",
	"F_DM14",
	"F_DM15",
	"F_DM17",
	"F_DM18",
	"F_DM19",
	"F_DM20",
	"F_DM21",
	"F_DM22",
	"F_DM23",
	"F_DM24",
	"F_DM25",
	"F_DM27",
	"F_DM28",
	"F_DM29",
	"F_DM2INT",
	"F_DM2TTL",
	"F_DM30",
	"F_DM31",
	"F_INTER",
	"F_MAP01",
	"F_MAP02",
	"F_MAP03",
	"F_MAP04",
	"F_MAP05",
	"F_MAP06",
	"F_MAP07",
	"F_MAP08",
	"F_MAP09",
	"F_MAP10",
	"F_MAP11",
	"F_MAP12",
	"F_MAP13",
	"F_MAP14",
	"F_MAP15",
	"F_MAP16",
	"F_MAP17",
	"F_MAP18",
	"F_MAP19",
	"F_MAP20",
	"F_MAP21",
	"F_MAP22",
	"F_MAP23",
	"F_MAP24",
	"F_MAP25",
	"F_MAP26",
	"F_MAP27",
	"F_MAP28",
	"F_MAP29",
	"F_MAP30",
	"F_MAP31",
	"F_MAP32",
	"F_READ_M",
	"F_VICTOR",
	"D_H_E1M1", // Heretic
	"D_H_E1M2",
	"D_H_E1M3",
	"D_H_E1M4",
	"D_H_E1M5",
	"D_H_E1M6",
	"D_H_E1M7",
	"D_H_E1M8",
	"D_H_E1M9",
	"D_H_E2M1",
	"D_H_E2M2",
	"D_H_E2M3",
	"D_H_E2M4",
	"D_H_E2M6",
	"D_H_E2M7",
	"D_H_E2M8",
	"D_H_E2M9",
	"D_H_E3M2",
	"D_H_E3M3",
	"D_H_CPTD",
	"WINNOWR", // Hexen
	"JACHR",
	"SIMONR",
	"WUTZITR",
	"FALCONR",
	"LEVELR",
	"CRYPTR",
	"SWAMPR",
	"DEEPR",
	"FUBASR",
	"GROVER",
	"FORTR",
	"VOIDR",
	"CHAP_1R",
	"CHAP_2R",
	"CHAP_3R",
	"CHAP_4R",
	"SECRETR",
	"CHIPPYR",
	"PERCR",
	"FOOJAR",
	"SIXATER",
	"WOBABYR",
	"FANTAR",
	"BLECHR",
	"BONESR",
	"OCTOR",
	"RITHMR",
	"STALKR",
	"BORKR",
	"CRUCIBR",
	"CHARTR",
	"HUB",
	"HALL",
	"ORB",
	"CHESS",
	"CASA1", // Hexen 2
	"CASA2",
	"CASA3",
	"CASA4",
	"EGYP1",
	"EGYP2",
	"EGYP3",
	"MESO1",
	"MESO2",
	"MESO3",
	"ROMA1",
	"ROMA2",
	"ROMA3",
	"CASB1",
	"CASB2",
	"CASB3",
	"TULKU1", // Hexen 2 Expansion
	"TULKU2",
	"TULKU3",
	"TULKU4",
	"TULKU5",
	"TULKU6",
	"TULKU7",
	"TULKU8",
	"TULKU9",
	"TULKU10",
	"CCCOOL", // ROTT
	"CHANT",
	"EVINRUDE",
	"EXCALIBR",
	"FASTWAY",
	"GAZZ",
	"HELLERO",
	"HOWDIDO",
	"KISSOFF",
	"MEDIEV1A",
	"MISTACHE",
	"OWW",
	"RADAGIO",
	"RISE",
	"RUNLIKE",
	"SHARDS",
	"SMOKE",
	"SMOOTH",
	"SPRAY",
	"STAIRS",
	"SUCKTHIS",
	"TASKFORC",
	"WATZNEXT",
	"WHERIZIT",
	"WORK_DAY",
	"YOUSUCK",
	"D_C_E1M1", // Chex Quest
	"D_C_E1M2",
	"D_C_E1M3",
	"D_C_E1M4",
	"D_C_E1M5",
	"D_C_E2M1",
	"D_C_E2M2",
	"D_C_E2M3",
	"D_C_E2M4",
	"D_C_E2M5",
	"D_C_E3M1",
	"D_C_E3M2",
	"D_C_E3M3",
	"D_C_E3M4",
	"D_C_E3M5",
	"D_C_INTR",
	"D_C_VICT",
	"D_C_BUNN",
	"S_ACTION", // Strife
	"S_CASTLE",
	"S_DANGER",
	"S_DARK",
	"S_DARKER",
	"S_DRONE",
	"S_FAST",
	"S_FIGHT",
	"S_INSTRY",
	"S_MARCH",
	"S_MOOD",
	"S_PANTHR",
	"S_SAD",
	"S_SLIDE",
	"S_SPENSE",
	"S_STRIKE",
	"S_TECH",
	"S_TRIBAL",
	"S_MAP3",
	"G_CASTLE", // Shadowcaster
	"G_COMBT1",
	"G_COMBT2",
	"G_DRKMAN",
	"G_LOBSTR",
	"G_NEWINT",
	"G_ROCK",
	"G_RUINS",
	"G_SHRIN1",
	"G_SSAIR",
	"G_TEMPLE",
	"G_UNDGND",
	"G_UNDWTR",
	"G_VOICES",
	"G_WOLF",
	"G_ZARDAZ",
	"MAR1LAND", // Marathon
	"MAR1ALIN", 
	"MAR1CHOM",
	"MAR1LEEL",
	"MAR1PAC1",
	"MAR1PAC2",
	"MAR1RPRU",
	"MAR1RUSH",
	"MAR1SPLS",
	"MAR1SWRL",
	"MAR1BOB",
	"MAR1FAT",
	"MAR1FLIP",
	"MAR1FLOW",
	"MAR1FREE",
	"MAR1GUAR",
	"D_CENT01", // Descent
	"D_CENT02",
	"D_CENT03",
	"D_CENT04",
	"D_CENT05",
	"D_CENT06",
	"D_CENT07",
	"D_CENT08",
	"D_CENT09",
	"D_CENT10",
	"D_CENT11",
	"D_CENT12",
	"D_CENT13",
	"D_CENT14",
	"D_CENT15",
	"D_CENT16",
	"D_CENT17",
	"D_CENT18",
	"D_CENT19",
	"D_CENT20",
	"D_CENT21",
	"D_CENT22",
	"D_CENT23",
	"D_CENT24",
	"D_CENT25",
	"D_CENT26",
	"D_CEN2TT", // Descent 2
	"D_CEN2BF",
	"D_CEN2CR",
	"D_CEN2EG",
	"D_CEN2_1",
	"D_CEN2_2",
	"D_CEN2_3",
	"D_CEN2_4",
	"CBUNHOLY", // Blood
	"CBLOOD1",
	"CBLOOD2",
	"CBLOOD3",
	"CBLOOD4",
	"CBLOOD5",
	"CBLOOD6",
	"CBLOOD7",
	"CBLOOD8",
	"CBLOOD9",
	"CBLOOD10",
	"CBSETUP",
	"CBPESTIS",
	"PBLOOD1", // Blood Proto
	"PBLOOD2",
	"PBLOOD3",
	"PBLOOD4",
	"PBLOOD5",
	"PBLOOD7",
	"PBLOOD8",
	"PBLOOD11",
	"PBLOOD12",
	"PBDEMO1",
	"PBDEMO2",
	"BS1DKHAL", // Blake Stone
	"BS1HIDNG",
	"BS1INTRG",
	"BS1JUNGL",
	"BS1RACSH",
	"BS1SEARC",
	"BS12100",
	"ABUSE00", // Abuse
	"ABUSE01",
	"ABUSE02",
	"ABUSE04",
	"ABUSE06",
	"ABUSE08",
	"ABUSE09",
	"ABUSE11",
	"ABUSE13",
	"ABUSE17"
};

// Copied from ijon's commonfuncs.h
function int defaultCVar(int cvar, int defaultVal)
{
    int ret = GetCVar(cvar);
    if (ret == 0) { saveCVar(cvar, defaultVal); return defaultVal; }

    return ret;
}

function void saveCVar(int cvar, int val)
{
    int setStr = StrParam(s:"set ", s:cvar, s:" ", d:val);
    int arcStr = StrParam(s:"archivecvar ", s:cvar);
    ConsoleCommand(setStr); ConsoleCommand(arcStr);
}

// The Random Music Script Itself
Script 346 OPEN NET clientside
{
int i;
int randomhack;
int lastmus;
	if (GameType () != GAME_TITLE_MAP)
	{
    if (GetCvar("norandommusic") == 0)
    {
        MusicRandomizerOn = 1;
        if (GetCvar("mus_runninginzdoom") == 1)
        {
            i = random(0, RANDOMMUS-1);
            SetMusic(RandMusList[i],0);
        }
        else
        // Zandronum is funny about this. Online, it generates the same random seed every
        // time, even though that's the opposite of what you'd expect from a random call.
        // I have to use a workaround to generate pseudo-random behavior.
        // But it's better than dealing with ZDoom's barely-functional slapshod netcode!
        {
            randomhack = defaultCVar("mus_cl_randomhack",   0);
            lastmus    = defaultCVar("mus_cl_lastmusic",    0) - 1;

            for (i = 0; i < randomhack; i++) { random(0, 1); }
            randomhack = random(0, 500);
            SaveCVar("mus_cl_randomhack", randomhack);

            do { i = random(0, RANDOMMUS-1); }
            while (i == lastmus);

			SetMusic(RandMusList[i], 0);
            SaveCVar("mus_cl_lastmusic", i + 1);
        }
        Delay(35);
        if (GetCvar("nomusicinfo") == 0)
        {
            MusicInfo = strparam(s:"DESC_", s:RandMusList[i]);
            SetFont("TinyFont");
			SetHudSize(320,240,1);
            hudmessage(l:MusicInfo; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 6.1, 160.2, 3.0, 0.5, 1.0);
			hudmessage(l:MusicInfo; HUDMSG_FADEINOUT, 154, CR_BLACK, 7.1, 161.2, 3.0, 0.5, 1.0);
        }
    }
    else
    {
        MusicRandomizerOn = 0;
    }
	}
}

script 347 OPEN clientside
{
    delay(1);
    if (GetCvar("mus_runninginzdoom") == 0) // No option to disable on ZDoom because I'm pretty sure the only way this'll
    {                                       // be happening is when you manually load it, ergo want to listen to it...
        if (!GetCvar("norandommusic"))
            { ConsoleCommand("set norandommusic 0");
              ConsoleCommand("archivecvar norandommusic"); }
        if (!GetCvar("nomusicinfo"))
            { ConsoleCommand("set nomusicinfo 0");
              ConsoleCommand("archivecvar nomusicinfo"); }
    }
}

script 348 (int musicshit) NET clientside
{
int i;
int randomhack;
int lastmus;

switch (musicshit)
{
  case 0:
    SetMusic("silence");
    LocalAmbientSound("music/shift",127);
    Delay(35);
    if (GetCvar("norandommusic") == 0)
    {
        MusicRandomizerOn = 1;
        if (GetCvar("mus_runninginzdoom") == 1)
        {
            i = random(0, RANDOMMUS-1);
            SetMusic(RandMusList[i],0);
        }
        else
        {
            randomhack = defaultCVar("mus_cl_randomhack",   0);
            lastmus    = defaultCVar("mus_cl_lastmusic",    0) - 1;

            for (i = 0; i < randomhack; i++) { random(0, 1); }
            randomhack = random(0, 500);
            SaveCVar("mus_cl_randomhack", randomhack);

            do { i = random(0, RANDOMMUS-1); }
            while (i == lastmus);
            SetMusic(RandMusList[i], 0);
            SaveCVar("mus_cl_lastmusic", i + 1);
        }
        if (GetCvar("nomusicinfo") == 0)
        {
			MusicInfo = strparam(s:"DESC_", s:RandMusList[i]);
            SetFont("TinyFont");
			SetHudSize(320,240,0);
            hudmessage(l:MusicInfo; HUDMSG_FADEINOUT | HUDMSG_LOG, 153, CR_WHITE, 6.1, 160.2, 3.0, 0.5, 1.0);
			hudmessage(l:MusicInfo; HUDMSG_FADEINOUT, 154, CR_BLACK, 7.1, 161.2, 3.0, 0.5, 1.0);
        }
    }
    else
    {
        MusicRandomizerOn = 0;
        SetMusic("*",0);
    }
    break;

  case 1:
    SetMusic("silence");
    LocalAmbientSound("music/shift",127);
    Delay(35);
    SetMusic("*",0);
    break;
}
}